header "More On Locales"

(*<*)
theory Demo2 imports Demo14 begin
(*>*)

locale agroup = group +
  assumes com: "x \<cdot> y = y \<cdot> x"

text (in agroup) {*
  We are now in the @{text agroup} context where assumption
  @{thm [source] com}: @{thm com} is visible without
  any further premises.

  All inherited and proved theorems of the @{text group} context
  are available as well:

  @{thm assoc}

  @{thm l_one}

  @{thm l_inv}

  @{thm r_one}

  @{thm r_inv}
  
  etc.
*}

text {*
  Outside the context, these theorems would look like this.
  (for fun we replace @{text "\<Longrightarrow>"} by @{text "\<longrightarrow>"} in \LaTeX).

  \renewcommand{\isasymLongrightarrow}{\isasymlongrightarrow}
  
  @{thm agroup.com} 

  @{thm semi.assoc}

  @{thm group.l_one}

  @{thm group.l_inv}

  @{thm group.r_one}

  @{thm group.r_inv}
*}

text {* Changing existing output syntax: *}

syntax (latex output)
  Cons :: "'a \<Rightarrow> 'a list \<Rightarrow> 'a list" ("_\<cdot>/_" [66,65] 65)

text {*
  Now existing function definitions look different:  
  @{thm [display] map.simps}

  \bigskip

  Creating new symbols and changing output syntax:
*}

text_raw {* \newcommand{\isasymnotex}{\isamath{\neg\exists}} *}

syntax (latex)
  notEx         :: "('a => bool) => bool"  (binder "\<notex>" 10)
translations
  "\<notex>x. P" == "\<not>(\<exists>x. P)"

lemma "(\<forall>x. \<not>P x) = (\<notex>x. P x)" by blast

(*<*)
end
(*>*)
